.386
.model flat,stdcall
option casemap:none
include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdi32.inc
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib

WinMain proto :DWORD,:DWORD,:DWORD,:DWORD

.data
ClassMyButton db "MyButton",0
ClassName db "SimpleWinClass",0
ClassStatic db "Static",0
AppName  db "Our First Window",0
HbutBrush dd 0
.data?
hInstance HINSTANCE ?
CommandLine LPSTR ?
hButton dd ?
hImage dd ?
hbmpdown dd ?
hbmpup dd ?
.const
IDB_BUTTONDOWN	equ	500
IDB_BUTTONUP	equ	501
.code      

RGB MACRO red, green, blue
        xor eax, eax
        mov ah, blue    ; blue
        mov al, green   ; green
        rol eax, 8
        mov al, red     ; red
      ENDM
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	invoke GetCommandLine
	mov    CommandLine,eax
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	INVOKE	LoadBitmap,hInstance,IDB_BUTTONDOWN
	mov	hbmpdown,eax
	INVOKE	LoadBitmap,hInstance,IDB_BUTTONUP
	mov	hbmpup,eax
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInstance
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_WINDOW+1
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	invoke RegisterClassEx, addr wc
	mov   wc.lpfnWndProc, OFFSET MyButtonProc
	mov   wc.lpszClassName,OFFSET ClassMyButton
	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
           CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax
	invoke ShowWindow, hwnd,SW_SHOWNORMAL
	invoke UpdateWindow, hwnd
	.WHILE TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.ENDW
	mov     eax,msg.wParam
	ret
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	.IF uMsg==WM_CREATE
		INVOKE CreateWindowEx,WS_EX_TRANSPARENT,ADDR ClassMyButton,NULL,\
			WS_CHILD or WS_VISIBLE,\
			0,0,50,25,hWnd, NULL, hInstance, NULL
    		mov   hButton,eax
	.ELSEIF uMsg==WM_DESTROY
		INVOKE	DeleteObject,hbmpdown
		INVOKE	DeleteObject,hbmpup
		invoke PostQuitMessage,NULL
	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.ENDIF
	xor eax,eax
	ret
WndProc endp

MyButtonProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	.IF	uMsg==WM_MOUSEMOVE
		and	wParam,MK_LBUTTON
		jz	DefaultProc00
		INVOKE	GetCapture									;user32.dll
		cmp	eax,hWnd
		jne	DefaultProc00
		mov	eax,lParam
		mov	ecx,eax
		shr	ecx,16
		cmp	ax,49
		ja	ButtonUp00
		cmp	cx,24
		ja	ButtonUp00
		jmp	ButtonDown00
	.ELSEIF uMsg==WM_LBUTTONDOWN
		INVOKE	SetCapture,hWnd									;user32.dll
ButtonDown00:
		INVOKE	SendMessage,hImage,STM_SETIMAGE,IMAGE_BITMAP,hbmpdown				;user32.dll
	.ELSEIF uMsg==WM_LBUTTONUP
		INVOKE	ReleaseCapture									;user32.dll
		jmp	ButtonUp00
	.ELSEIF uMsg==WM_CREATE
		INVOKE CreateWindowEx,0,ADDR ClassStatic,NULL,\
			WS_CHILD or WS_VISIBLE or SS_BITMAP,\
			0,0,50,25,hWnd, NULL, hInstance, NULL
    		mov   hImage,eax
		INVOKE	SetWindowPos,hWnd,HWND_TOP,0,0,50,25,SWP_NOMOVE					;user32.dll
ButtonUp00:
		INVOKE	SendMessage,hImage,STM_SETIMAGE,IMAGE_BITMAP,hbmpup				;user32.dll
	.ELSE
DefaultProc00:
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.ENDIF
	xor eax,eax
	ret
MyButtonProc endp


end start
